#ifndef _bisq_Ff_h
#define _bisq_Ff_h

#include <stdio.h>
#include <rfftw.h>
#include <errno.h>

/* Support the Recording Server? This does not work yet. */
#define SUPPORT_RS 0

/* Just print out a sample? Only for debugging purposes... */
#define VALDEBUG 0

#define NEED_POW2 1

/* Samplaustaajuus */
#define FREQ	44100

/* Kuinka iso palanen kerralla skannataan */
#define N		22050

/* FREQ/2 on maksimitaajuus joka voidaan ksitell. */

/* Palasen koko pit olla vhintn 1/x sekuntia eli FREQ/x samplea, jos x on pienin haluttu taajuus. */

/* Kuinka monta skannausta samalle palalle voidaan tehd (askellus) */
#define PALASIA  3

#define Step	((FREQ / PALASIA)<N?(FREQ/PALASIA):N)
				/* Stepin pit olla <= N, muuten tippuu jotain
				 * vlist. Jotenka siis l valitse pienempi
				 * arvoja PALASIA-kohtaan kuin FREQ/N, muuten
				 * tulos ei ole mit odotit.
				 *
				 * Valitse mielelln kuitenkin isompi arvo
				 * kuin FREQ/N, sill muuten ohjelma blokkaa
				 * odottaessaan uutta dataa, mik nkyy nykimisen.
				 */

typedef signed short intype;

#define inadd 32768
#define inmax 65536

extern fftw_real In[N];
extern fftw_real Power[N/2+1];

/* If nonzero, must exit as quickly as possible. */
extern int Quittah;

/* The general trap-routine */
static int _ff_errorcode;
#define Trap(eq) (((_ff_errorcode=(eq))<0)?InvTrap(#eq,__LINE__,__FILE__):_ff_errorcode)
static int InvTrap(const char *s, int l, const char *f)
{
	printf(
		"Error %d (%%) at line %d in %s\n"
		"This failed: %s\n\n",
		errno, l, f, s);
		
	exit(_ff_errorcode);
}

#endif	/* _bisq_Ff_h defined */
